<?php

srand(1);

ini_set('display_errors', 0);
error_reporting(E_ALL);

$tunnels = imagecreatetruecolor(800, 600);
$background = imagecolorallocate($tunnels, 255, 255, 255);
$line_colour = imagecolorallocate($tunnels, 0, 0, 0);

imagefill($tunnels, 0, 0, $background);

imageantialias($tunnels, true);
imagesetthickness($tunnels, 6);

$no_of_entrances = floor(sqrt(rand(1, 4)))+1;
$entrances = array();
$rooms = array();

$direction = rand(1, 4);

for($i = 0; $i < $no_of_entrances; $i++)
{
	switch($direction)
	{
		case 1:
			$temp = array('x' => 0, 'y' => rand(200, 400), 'w' => 20, 'h' => 20, 'd' => 'right');
			break;
		case 2:
			$temp = array('x' => rand(200, 600), 'y' => 0, 'w' => 20, 'h' => 20, 'd' => 'down');
			break;
		case 3:
			$temp = array('x' => 800, 'y' => rand(200, 400), 'w' => 20, 'h' => 20, 'd' => 'left');
			break;
		case 4:
			$temp = array('x' => rand(200, 600), 'y' => 600, 'w' => 20, 'h' => 20, 'd' => 'up');
			break;
	}
	$entrances[] = $temp;
	$rooms[] = $temp;
}

$no_of_entraces = rand(1, 3);

for($i = 0; $i < $no_of_entrances; $i++)
{
	$x = rand(150, 750);
	$y = rand(150, 450);
	
	if($x < 350) $d = 'right';
	else if($x > 450) $d = 'left';
	else if($y < 300) $d = 'down';
	else $d = 'up';
	
	$temp = array('x' => $x, 'y' => $y, 'w' => sqrt(rand(4000, 8000)), 'h' => sqrt(rand(4000, 8000)), 'd' => $d);

	$entrances[] = $temp;
	$rooms[] = $temp;
}


foreach($entrances AS $entrance)
{
	$length = rand(50, 80);
	$x = $entrance['x'];
	$y = $entrance['y'];
	
	$tilt = rand(0, 10)-5;
	
	for($i = 0; $i < $length; $i++)
	{
		$displacement = rand(0,20) - 10 + $tilt;
		$w = 20;
		$h = 20;
		if(rand(1, 25) == 1)
		{
			$w = sqrt(rand(0, 8000))+30;
			$h = sqrt(rand(0, 8000))+30;
		}
		else
		{
			$w = 15 + rand(0, 10);
			$h = 15 + rand(0, 10);
		}
				
		switch($entrance['d'])
		{
			case 'right':
				$x += 6;
				$y += $displacement;
				$rooms[] = array('x' => $x, 'y' => $y, 'w' => $w, 'h' => $h);
				break;
			case 'down':
				$x += $displacement;
				$y += 6;
				$rooms[] = array('x' => $x, 'y' => $y, 'w' => $w, 'h' => $h);
				break;
			case 'left':
				$x -= 6;
				$y += $displacement;
				$rooms[] = array('x' => $x, 'y' => $y, 'w' => $w, 'h' => $h);
				break;
			case 'up':
				$x += $displacement;
				$y -= 6;
				$rooms[] = array('x' => $x, 'y' => $y, 'w' => $w, 'h' => $h);
				break;
		}
	}
	$rooms[] = array('x' => $x, 'y' => $y, 'w' => sqrt(rand(4000, 8000)), 'h' => sqrt(rand(4000, 8000)));
}

foreach($rooms AS $room)
{
	draw_room($room);
}

foreach($rooms AS $room)
{
	imagefilledellipse($tunnels, $room['x'], $room['y'], $room['w'], $room['h'], $background);
}

//die();

header("Content-type: image/png");
imagepng($tunnels);

imagecolordeallocate($line_colour);
imagecolordeallocate($background);
imagedestroy($my_img);


function draw_room(array $room)
{
	global $tunnels;
	global $line_colour;
	
	$x0 = $room['x'] - $room['w'] / 2;
	$x1 = $room['x'] + $room['w'] / 2;
	$y0 = $room['y'] - $room['h'] / 2;
	$y1 = $room['y'] + $room['h'] / 2;
	
		
	$a = $room['w'];
	$b = $room['h'];
	$b1 = $b & 1;
  	$dx = 4*(1-$a)*$b*$b;
  	$dy = 4*($b1+1)*$a*$a;
	$err = $dx+$dy+$b1*$a*$a;
	$e2;
	
   	if ($x0 > $x1)
   	{
	   	$x0 = $x1;
	   	$x1 += $a;
	}
   	if ($y0 > $y1)
   	{
	   	$y0 = $y1;
   	}
   	$y0 += ($b+1)/2;
   	$y1 = $y0-$b1;
   	$a *= 8*$a;
   	$b1 = 8*$b*$b;

   	$i = 0;

	$q = array();
	
	$q[0] = array('x' => $x0-1, 'y' => $y0+1);
	$q[1] = array('x' => $x0-1, 'y' => $y1-1);
	$q[2] = array('x' => $x1+1, 'y' => $y0+1);
	$q[3] = array('x' => $x1+1, 'y' => $y1-1);

   	do
   	{
	   	$i++;
	   	if($i % 10 == 0)
	   	{
		   	foreach($q AS $key => $quadrant)
		   	{
			   	switch($key)
			   	{
				   	case 0:
				   		$endx = $x0 + (rand(1, 5) * -1);
				   		$endy = $y0 + rand(1, 5);
				   		break;
				   	case 1:
				   		$endx = $x0 + (rand(1, 5) * -1);
				   		$endy = $y1 + (rand(1, 5) * -1);
				   		break;
				   	case 2:
				   		$endx = $x1 + rand(1, 5);
				   		$endy = $y0 + rand(1, 5);
				   		break;
				   	case 3:
				   		$endx = $x1 + rand(1, 5);
				   		$endy = $y1 + (rand(1, 5) * -1);
				   		break;
			   	}
				imageline($tunnels, $quadrant['x'], $quadrant['y'], $endx, $endy, $line_colour);
				$q[$key]['x'] = $endx;
				$q[$key]['y'] = $endy;
			}
	   	}

    	$e2 = 2*$err;
    	if ($e2 <= $dy)
    	{
	    	$y0++;
	    	$y1--;
	    	$err += $dy += $a;
	    }
    	if ($e2 >= $dx || 2*$err > $dy)
    	{
	    	$x0++;
	    	$x1--;
	    	$err += $dx += $b1;
	    }
	} while ($x0 <= $x1);
	
	imageline($tunnels, $q[0]['x'], $q[0]['y'], $q[2]['x'], $q[2]['y'], $line_colour);
	imageline($tunnels, $q[1]['x'], $q[1]['y'], $q[3]['x'], $q[3]['y'], $line_colour);
   
}

?>